﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using XPBurn;

namespace WinMasterizzaCS
{
    public partial class Form1 : Form
    {
        //Oggetto a livello globale per la gestione degli eventi e metodi
        private XPBurn.XPBurnCD ObjMasterizza;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            //carico in una combo i nomi delle unità dove si può masterizzare
            ObjMasterizza = new XPBurnCD();
            for (int Intconta = 0; Intconta < ObjMasterizza.RecorderDrives.Count; Intconta++)
            {
                ObjMasterizza.BurnerDrive = ObjMasterizza.RecorderDrives[Intconta].ToString();
                cmbdrive.Items.Add(ObjMasterizza.ProductID);
            }

            //imposto la prima unità
            if (cmbdrive.Items.Count > 0)
                cmbdrive.SelectedIndex = 0;

        }

        private void BtnEspelle_Click(object sender, EventArgs e)
        {
            //Espelle il cd
            ObjMasterizza.Eject();
        }

        private void cmbdrive_SelectedIndexChanged(object sender, EventArgs e)
        {
            //scelta dell'unità per masterizzare
            ObjMasterizza.BurnerDrive = ObjMasterizza.RecorderDrives[cmbdrive.SelectedIndex].ToString();
        }

        private void ObjMasterizza_AddProgress(int nCompletedSteps, int nTotalSteps)
        {
            // aggiornamento della barra 
            PgbPreparazione.Maximum = nTotalSteps;
            PgbPreparazione.Value = nCompletedSteps;
        }

        // evento che avviene prima di registrare. Prepara il cd
        private void ObjMasterizza_PreparingBurn(int nEstimatedSeconds)
        {
            lstTesto.Items.Add(("Preparazione in corso....Tempo richiesto : " + nEstimatedSeconds));
        }
        // evento che ci fornisce informazioni sullo stato della copia
        private void ObjMasterizza_BlockProgress(int nCompletedSteps, int nTotalSteps)
        {
            PgbScrittura.Maximum = nTotalSteps;
            PgbScrittura.Value = nCompletedSteps;
        }
        // evento che si verifica quando ha completato di copiare su cd
        private void ObjMasterizza_BurnComplete(System.UInt32 status)
        {
            PgbScrittura.Maximum = 0;
            PgbScrittura.Value = 0;
            lstTesto.Items.Add("Operazione Completata");
        }

        // evento per la chiusura del cd
        private void ObjMasterizza_ClosingDisc(int nEstimatedSeconds)
        {
            lstTesto.Items.Add(("Chiusura disco attendere..."
                            + (nEstimatedSeconds + " Secondi")));
        }
        private void btnaggiungi_Click(object sender, System.EventArgs e)
        {
            if (!System.IO.File.Exists(txtfile.Text))
            {
                return;
            }
            // aggiungo i file da copiare su cd
            ObjMasterizza.AddFile(txtfile.Text, txtfile.Text);
            lstFile.Items.Add(txtfile.Text);
        }

        private void btntrova_Click(object sender, EventArgs e)
        {
            OpenFileDialog DlgApri = new OpenFileDialog();
            // cerco i file da copiare
            if ((DlgApri.ShowDialog() == DialogResult.OK))
            {
                txtfile.Text = DlgApri.FileName;
            }
        }

        private void BtnCopia_Click(object sender, EventArgs e)
        {
            try
            {
                // true test simulazione
                // metodo che avvia la copia su cd il primo valore se è settato a true fa un test, il secondo espelle il cd a termine operazione
                ObjMasterizza.RecordDisc(false, true);
            }
            catch (XPBurnException ex)
            {
                MessageBox.Show(ex.Message);
            }
        }



    }
}
